Index: /trunk/ReleaseNotes
===================================================================
--- /trunk/ReleaseNotes	(revision 121)
+++ /trunk/ReleaseNotes	(revision 122)
@@ -3,4 +3,9 @@
 - added fixed cameras in simulator, see $FLAIR_ROOT/flair-bin/models/indoor_fligh
 t_arena.xml for an exemple
+- added lib/FlairVisionFilter: some basic vision algorithms using opencv. Note that this lib can be remplaced by HdsVisionFilter if you have access to it, in order to use the DSP in HDS UAV's.
+See also https://devel.hds.utc.fr/software/flair/wiki/hds_users
+- added demos/OpticalFlow: stabilization using optical flow (vertical camera)
+- Uav class is now a singleton
+- VrpnClient class is now a singleton
 
 -----------------------------------------------------------
Index: /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp
===================================================================
--- /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp	(revision 121)
+++ /trunk/demos/CircleFollower/uav/src/CircleFollower.cpp	(revision 122)
@@ -39,24 +39,29 @@
 using namespace flair::meta;
 
-CircleFollower::CircleFollower(Uav* uav,TargetController *controller): UavStateMachine(uav,controller), behaviourMode(BehaviourMode_t::Default), vrpnLost(false) {
-    uav->SetupVRPNAutoIP(uav->ObjectName());
-
+CircleFollower::CircleFollower(TargetController *controller): UavStateMachine(controller), behaviourMode(BehaviourMode_t::Default), vrpnLost(false) {
+    Uav* uav=GetUav();
+		
+		VrpnClient* vrpnclient=new VrpnClient("vrpn", uav->GetDefaultVrpnAddress(),10000, 80);
+		uavVrpn = new MetaVrpnObject(uav->ObjectName());
+		getFrameworkManager()->AddDeviceToLog(uavVrpn);
+		uav->GetAhrs()->YawPlot()->AddCurve(uavVrpn->State()->Element(2),DataPlot::Green);
+																 
     startCircle=new PushButton(GetButtonsLayout()->NewRow(),"start_circle");
     stopCircle=new PushButton(GetButtonsLayout()->LastRowLastCol(),"stop_circle");
 
-    if(uav->GetVrpnClient()->UseXbee()==true) {
-        targetVrpn=new MetaVrpnObject(uav->GetVrpnClient(),"target",1);
+    if(vrpnclient->UseXbee()==true) {
+        targetVrpn=new MetaVrpnObject("target",1);
     } else {
-        targetVrpn=new MetaVrpnObject(uav->GetVrpnClient(),"target");
+        targetVrpn=new MetaVrpnObject("target");
     }
 
     getFrameworkManager()->AddDeviceToLog(targetVrpn);
 
-    circle=new TrajectoryGenerator2DCircle(uav->GetVrpnClient()->GetLayout()->NewRow(),"circle");
-    uav->GetVrpnObject()->xPlot()->AddCurve(circle->Matrix()->Element(0,0),DataPlot::Blue);
-    uav->GetVrpnObject()->yPlot()->AddCurve(circle->Matrix()->Element(0,1),DataPlot::Blue);
-    uav->GetVrpnObject()->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),DataPlot::Blue);
-    uav->GetVrpnObject()->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),DataPlot::Blue);
-    uav->GetVrpnObject()->XyPlot()->AddCurve(circle->Matrix()->Element(0,1),circle->Matrix()->Element(0,0),DataPlot::Blue,"circle");
+    circle=new TrajectoryGenerator2DCircle(vrpnclient->GetLayout()->NewRow(),"circle");
+    uavVrpn->xPlot()->AddCurve(circle->Matrix()->Element(0,0),DataPlot::Blue);
+    uavVrpn->yPlot()->AddCurve(circle->Matrix()->Element(0,1),DataPlot::Blue);
+    uavVrpn->VxPlot()->AddCurve(circle->Matrix()->Element(1,0),DataPlot::Blue);
+    uavVrpn->VyPlot()->AddCurve(circle->Matrix()->Element(1,1),DataPlot::Blue);
+    uavVrpn->XyPlot()->AddCurve(circle->Matrix()->Element(0,1),circle->Matrix()->Element(0,0),DataPlot::Blue,"circle");
 
     uX=new Pid(setupLawTab->At(1,0),"u_x");
@@ -79,5 +84,5 @@
     //get yaw from vrpn
     Euler vrpnEuler;
-    GetUav()->GetVrpnObject()->GetEuler(vrpnEuler);
+    uavVrpn->GetEuler(vrpnEuler);
 
     //get roll, pitch and w from imu
@@ -98,6 +103,6 @@
     Vector3D uav_pos,uav_vel;
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
-    GetUav()->GetVrpnObject()->GetSpeed(uav_vel);
+    uavVrpn->GetPosition(uav_pos);
+    uavVrpn->GetSpeed(uav_vel);
     //z and dz must be in uav's frame
     z=-uav_pos.z;
@@ -131,6 +136,6 @@
     Vector2D uav_2Dpos,uav_2Dvel; // in VRPN coordinate system
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
-    GetUav()->GetVrpnObject()->GetSpeed(uav_vel);
+    uavVrpn->GetPosition(uav_pos);
+    uavVrpn->GetSpeed(uav_vel);
 
     uav_pos.To2Dxy(uav_2Dpos);
@@ -195,5 +200,5 @@
             Land();
         }
-        if (!GetUav()->GetVrpnObject()->IsTracked(500)) {
+        if (!uavVrpn->IsTracked(500)) {
             Thread::Err("VRPN, uav lost\n");
             vrpnLost=true;
@@ -239,5 +244,5 @@
     circle->SetCenter(target_2Dpos);
 
-    GetUav()->GetVrpnObject()->GetPosition(uav_pos);
+    uavVrpn->GetPosition(uav_pos);
     uav_pos.To2Dxy(uav_2Dpos);
     circle->StartTraj(uav_2Dpos);
@@ -258,8 +263,8 @@
     Vector3D vrpn_pos;
 
-    GetUav()->GetVrpnObject()->GetEuler(vrpn_euler);
+    uavVrpn->GetEuler(vrpn_euler);
     yawHold=vrpn_euler.yaw;
 
-    GetUav()->GetVrpnObject()->GetPosition(vrpn_pos);
+    uavVrpn->GetPosition(vrpn_pos);
     vrpn_pos.To2Dxy(posHold);
 
Index: /trunk/demos/CircleFollower/uav/src/CircleFollower.h
===================================================================
--- /trunk/demos/CircleFollower/uav/src/CircleFollower.h	(revision 121)
+++ /trunk/demos/CircleFollower/uav/src/CircleFollower.h	(revision 122)
@@ -34,5 +34,5 @@
 class CircleFollower : public flair::meta::UavStateMachine {
     public:
-        CircleFollower(flair::meta::Uav* uav,flair::sensor::TargetController *controller);
+        CircleFollower(flair::sensor::TargetController *controller);
         ~CircleFollower();
 
@@ -65,5 +65,5 @@
 
         flair::gui::PushButton *startCircle,*stopCircle;
-        flair::meta::MetaVrpnObject *targetVrpn;
+        flair::meta::MetaVrpnObject *targetVrpn,*uavVrpn;
         flair::filter::TrajectoryGenerator2DCircle *circle;
         flair::core::AhrsData *customReferenceOrientation,*customOrientation;
Index: /trunk/demos/CircleFollower/uav/src/main.cpp
===================================================================
--- /trunk/demos/CircleFollower/uav/src/main.cpp	(revision 121)
+++ /trunk/demos/CircleFollower/uav/src/main.cpp	(revision 122)
@@ -45,7 +45,7 @@
     manager->SetupLogger(log_path);
 
-    Uav* drone=CreateUav(manager,name,uav_type);
+    Uav* drone=CreateUav(name,uav_type);
     TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
-    CircleFollower* demo=new CircleFollower(drone,controller);
+    CircleFollower* demo=new CircleFollower(controller);
 
     demo->Start();
Index: /trunk/demos/Gps/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/Gps/uav/CMakeLists.txt	(revision 121)
+++ /trunk/demos/Gps/uav/CMakeLists.txt	(revision 122)
@@ -6,5 +6,4 @@
 SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
 SET(FLAIR_USE_META TRUE)
-SET(FLAIR_USE_VRPN TRUE)
 SET(FLAIR_USE_GPS TRUE)
 
Index: /trunk/demos/Gps/uav/src/DemoGps.cpp
===================================================================
--- /trunk/demos/Gps/uav/src/DemoGps.cpp	(revision 121)
+++ /trunk/demos/Gps/uav/src/DemoGps.cpp	(revision 122)
@@ -39,6 +39,6 @@
 using namespace flair::meta;
 
-DemoGps::DemoGps(Uav* uav,TargetController *controller): UavStateMachine(uav,controller), behaviourMode(BehaviourMode_t::Default) {
-
+DemoGps::DemoGps(TargetController *controller): UavStateMachine(controller), behaviourMode(BehaviourMode_t::Default) {
+		Uav* uav=GetUav();
     startCircle=new PushButton(GetButtonsLayout()->NewRow(),"start_circle");
     stopCircle=new PushButton(GetButtonsLayout()->LastRowLastCol(),"stop_circle");
Index: /trunk/demos/Gps/uav/src/DemoGps.h
===================================================================
--- /trunk/demos/Gps/uav/src/DemoGps.h	(revision 121)
+++ /trunk/demos/Gps/uav/src/DemoGps.h	(revision 122)
@@ -33,5 +33,5 @@
 class DemoGps : public flair::meta::UavStateMachine {
     public:
-        DemoGps(flair::meta::Uav* uav,flair::sensor::TargetController *controller);
+        DemoGps(flair::sensor::TargetController *controller);
         ~DemoGps();
 
Index: /trunk/demos/Gps/uav/src/main.cpp
===================================================================
--- /trunk/demos/Gps/uav/src/main.cpp	(revision 121)
+++ /trunk/demos/Gps/uav/src/main.cpp	(revision 122)
@@ -45,7 +45,7 @@
     manager->SetupLogger(log_path);
 
-    Uav* drone=CreateUav(manager,name,uav_type);
+    Uav* drone=CreateUav(name,uav_type);
     TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
-    DemoGps* demo=new DemoGps(drone,controller);
+    DemoGps* demo=new DemoGps(controller);
 
     demo->Start();
Index: /trunk/demos/OpticalFlow/simulator/CMakeLists.txt
===================================================================
--- /trunk/demos/OpticalFlow/simulator/CMakeLists.txt	(revision 122)
+++ /trunk/demos/OpticalFlow/simulator/CMakeLists.txt	(revision 122)
@@ -0,0 +1,35 @@
+PROJECT(OpticalFlow_simulator)
+cmake_minimum_required(VERSION 2.8)
+
+SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
+SET(FLAIR_USE_SIMULATOR TRUE)
+SET(FLAIR_USE_SIMULATOR_GL TRUE)
+
+include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
+include(${FLAIR_USE_FILE})
+
+SET(SRC_FILES
+	${CMAKE_SOURCE_DIR}/src/main.cpp
+)
+
+LINK_DIRECTORIES (
+	${FLAIR_LIBRARY_DIR}
+)
+
+INCLUDE_DIRECTORIES(
+	${FLAIR_INCLUDE_DIR}
+)
+
+#real time executable
+ADD_EXECUTABLE(${PROJECT_NAME}_rt
+	${SRC_FILES}
+)
+
+TARGET_LINK_LIBRARIES(${PROJECT_NAME}_rt ${FLAIR_LIBRARIES_RT})
+
+#non real time executable
+ADD_EXECUTABLE(${PROJECT_NAME}_nrt
+	${SRC_FILES}
+)
+
+TARGET_LINK_LIBRARIES(${PROJECT_NAME}_nrt ${FLAIR_LIBRARIES_NRT})
Index: /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x4.sh
===================================================================
--- /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x4.sh	(revision 122)
+++ /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x4.sh	(revision 122)
@@ -0,0 +1,11 @@
+#! /bin/bash
+
+. $FLAIR_ROOT/flair-dev/scripts/ubuntu_cgroup_hack.sh
+
+if [ -f /proc/xenomai/version ];then
+	EXEC=./OpticalFlow_simulator_rt
+else
+	EXEC=./OpticalFlow_simulator_nrt
+fi
+
+$EXEC -n x4_0 -t x4 -a 127.0.0.1 -p 9000 -x setup_x4.xml -o 10 -m $FLAIR_ROOT/flair-bin/models -s $FLAIR_ROOT/flair-bin/models/indoor_flight_arena.xml
Index: /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x8.sh
===================================================================
--- /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x8.sh	(revision 122)
+++ /trunk/demos/OpticalFlow/simulator/build_x86_64/bin/simulator_x8.sh	(revision 122)
@@ -0,0 +1,11 @@
+#! /bin/bash
+
+. $FLAIR_ROOT/flair-dev/scripts/ubuntu_cgroup_hack.sh
+
+if [ -f /proc/xenomai/version ];then
+	EXEC=./OpticalFlow_simulator_rt
+else
+	EXEC=./OpticalFlow_simulator_nrt
+fi
+
+$EXEC -n x8_0 -t x8 -a 127.0.0.1 -p 9000 -x setup_x8.xml -o 10 -m $FLAIR_ROOT/flair-bin/models -s $FLAIR_ROOT/flair-bin/models/indoor_flight_arena.xml
Index: /trunk/demos/OpticalFlow/simulator/src/main.cpp
===================================================================
--- /trunk/demos/OpticalFlow/simulator/src/main.cpp	(revision 122)
+++ /trunk/demos/OpticalFlow/simulator/src/main.cpp	(revision 122)
@@ -0,0 +1,134 @@
+//  created:    2012/04/18
+//  filename:   main.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 6599
+//
+//  version:    $Id: $
+//
+//  purpose:    main simulateur
+//
+//
+/*********************************************************************/
+
+#include <tclap/CmdLine.h>
+#include <Simulator.h>
+#include <X4.h>
+#include <X8.h>
+#include <SimuImu.h>
+#ifdef GL
+#include <SimuCameraGL.h>
+#include <Parser.h>
+#include <SimuUsGL.h>
+#endif
+
+
+using namespace TCLAP;
+using namespace std;
+using namespace flair::simulator;
+using namespace flair::sensor;
+
+int port;
+int opti_time;
+string xml_file;
+string media_path;
+string scene_file;
+string type;
+string name;
+string address;
+
+void parseOptions(int argc, char** argv)
+{
+	try
+	{
+        CmdLine cmd("Command description message", ' ', "0.1");
+
+        ValueArg<string> nameArg("n","name","uav name, also used for vrpn",true,"x4","string");
+        cmd.add( nameArg );
+
+        ValueArg<string> xmlArg("x","xml","xml file",true,"./reglages.xml","string");
+        cmd.add( xmlArg );
+
+        ValueArg<int> portArg("p","port","ground station port",true,9002,"int");
+        cmd.add( portArg );
+
+        ValueArg<string> addressArg("a","address","ground station address",true,"127.0.0.1","string");
+        cmd.add( addressArg );
+
+        ValueArg<string> typeArg("t","type","uav type, x4 or x8",true,"x4","string");
+        cmd.add( typeArg );
+
+
+        ValueArg<int> optiArg("o","opti","optitrack time ms",false,0,"int");
+        cmd.add( optiArg );
+
+#ifdef GL
+        ValueArg<string> mediaArg("m","media","path to media files",true,"./","string");
+        cmd.add( mediaArg );
+
+        ValueArg<string> sceneArg("s","scene","path to scene file",true,"./voliere.xml","string");
+        cmd.add( sceneArg );
+#endif
+
+        cmd.parse( argc, argv );
+
+        // Get the value parsed by each arg.
+        port=portArg.getValue();
+        xml_file = xmlArg.getValue();
+        opti_time = optiArg.getValue();
+        type = typeArg.getValue();
+        name=nameArg.getValue();
+        address=addressArg.getValue();
+#ifdef GL
+        media_path=mediaArg.getValue();
+        scene_file=sceneArg.getValue();
+#endif
+
+	} catch (ArgException &e)  // catch any exceptions
+	{ cerr << "error: " << e.error() << " for arg " << e.argId() << endl; }
+}
+
+
+int main(int argc, char* argv[])
+{
+    Simulator *simu;
+    Model *drone;
+    SimuImu* imu;
+#ifdef GL
+    SimuUsGL* us_gl;
+
+    SimuCameraGL *cam_bas;
+    Parser *gui;
+#endif
+    parseOptions(argc,argv);
+
+    simu= new Simulator("simulator",opti_time,90);
+    simu->SetupConnection(address,port);
+    simu->SetupUserInterface(xml_file);
+
+#ifdef GL
+    gui=new Parser(simu,960,480,640,480,media_path,scene_file);
+#endif
+
+    if(type=="x4")
+    {
+        drone=new X4(simu,name,0);
+    }
+    else
+    {
+        drone=new X8(simu,name,0);
+    }
+    imu=new SimuImu(drone,"imu",0);
+
+#ifdef GL
+    us_gl=new SimuUsGL(drone,"us",0);
+    cam_bas=new SimuCameraGL(drone,"bottom camera",320,240,640,0,0);
+#endif
+
+    simu->RunSimu();
+
+    delete simu;
+
+	return 0;
+}
+
Index: /trunk/demos/OpticalFlow/uav/CMakeLists.txt
===================================================================
--- /trunk/demos/OpticalFlow/uav/CMakeLists.txt	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/CMakeLists.txt	(revision 122)
@@ -0,0 +1,34 @@
+PROJECT(OpticalFlow)
+cmake_minimum_required(VERSION 2.8)
+
+SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
+SET(FLAIR_USE_FILTER TRUE)
+#SET(FLAIR_USE_VISION_FILTER TRUE)
+SET(FLAIR_USE_SENSOR_ACTUATOR TRUE)
+SET(FLAIR_USE_META TRUE)
+
+include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
+include(${FLAIR_USE_FILE})
+
+SET(SRC_FILES
+	${CMAKE_SOURCE_DIR}/src/main.cpp
+	${CMAKE_SOURCE_DIR}/src/DemoOpticalFlow.cpp
+)
+
+INCLUDE_DIRECTORIES(
+	${FLAIR_INCLUDE_DIR}
+)
+
+#real time executable
+ADD_EXECUTABLE(${PROJECT_NAME}_rt
+	${SRC_FILES}
+)
+
+TARGET_LINK_LIBRARIES(${PROJECT_NAME}_rt ${FLAIR_LIBRARIES_RT})
+
+#non real time executable
+ADD_EXECUTABLE(${PROJECT_NAME}_nrt
+	${SRC_FILES}
+)
+
+TARGET_LINK_LIBRARIES(${PROJECT_NAME}_nrt ${FLAIR_LIBRARIES_NRT})
Index: /trunk/demos/OpticalFlow/uav/build_arm/bin/OpticalFlow_ardrone2.sh
===================================================================
--- /trunk/demos/OpticalFlow/uav/build_arm/bin/OpticalFlow_ardrone2.sh	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/build_arm/bin/OpticalFlow_ardrone2.sh	(revision 122)
@@ -0,0 +1,1 @@
+./demo_fo_nrt -a 192.168.147.193 -p 9000 -l /tmp -x OpticalFlow_ardrone2.xml -n Drone_0 -t ardrone2 -d ./dspcv_dsp.out
Index: /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x4.sh
===================================================================
--- /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x4.sh	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x4.sh	(revision 122)
@@ -0,0 +1,11 @@
+#! /bin/bash
+
+. $FLAIR_ROOT/flair-dev/scripts/ubuntu_cgroup_hack.sh
+
+if [ -f /proc/xenomai/version ];then
+	EXEC=./OpticalFlow_rt
+else
+	EXEC=./OpticalFlow_nrt
+fi
+
+$EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu -v dsp_stub
Index: /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x8.sh
===================================================================
--- /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x8.sh	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/build_x86_64/bin/x8.sh	(revision 122)
@@ -0,0 +1,11 @@
+#! /bin/bash
+
+. $FLAIR_ROOT/flair-dev/scripts/ubuntu_cgroup_hack.sh
+
+if [ -f /proc/xenomai/version ];then
+	EXEC=./OpticalFlow_rt
+else
+	EXEC=./OpticalFlow_nrt
+fi
+
+$EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x8.xml -t x8_simu -v dsp_stub
Index: /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.cpp	(revision 122)
@@ -0,0 +1,160 @@
+//  created:    2011/05/01
+//  filename:   DemoOpticalFlow.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    demo optical flow
+//
+//
+/*********************************************************************/
+
+#include "DemoOpticalFlow.h"
+#include <Uav.h>
+#include <Camera.h>
+#include <CvtColor.h>
+#include <OpticalFlow.h>
+#include <OpticalFlowSpeed.h>
+#include <LowPassFilter.h>
+#include <cvmatrix.h>
+#include <GridLayout.h>
+#include <DataPlot1D.h>
+#include <Tab.h>
+#include <TabWidget.h>
+#include <GroupBox.h>
+#include <DoubleSpinBox.h>
+#include <FrameworkManager.h>
+#include <MetaDualShock3.h>
+#include <Vector2D.h>
+#include <AhrsData.h>
+#include <Ahrs.h>
+#include <Pid.h>
+
+#include <stdio.h>
+
+using namespace std;
+using namespace flair::core;
+using namespace flair::gui;
+using namespace flair::filter;
+using namespace flair::meta;
+using namespace flair::sensor;
+
+DemoOpticalFlow::DemoOpticalFlow(TargetController *controller): UavStateMachine(controller) {
+  Uav* uav=GetUav();
+	if (uav->GetVerticalCamera() == NULL) {
+        exit(1);
+    }
+uav->GetVerticalCamera()->SetLogFormat(Camera::LogFormat::JPG);
+getFrameworkManager()->AddDeviceToLog(uav->GetVerticalCamera());
+    greyCameraImage=new CvtColor(uav->GetVerticalCamera(),"gray",CvtColor::Conversion_t::GRAY);
+
+    uav->GetVerticalCamera()->UseDefaultPlot(greyCameraImage->Output()); // Le defaultPlot de la caméra peut afficher n'importe quoi?
+
+    //optical flow stack
+    opticalFlow=new OpticalFlow(greyCameraImage,uav->GetVerticalCamera()->GetLayout()->NewRow(),"flux optique");
+    opticalFlowSpeed=new OpticalFlowSpeed(opticalFlow,"vitesse du flux optique");
+
+    cvmatrix_descriptor* desc=new cvmatrix_descriptor(2,1);
+    for(int i=0;i<2;i++) {
+        desc->SetElementName(i,0,opticalFlowSpeed->Output()->Name(i,0));
+    }
+    cvmatrix* prev_value=new cvmatrix((const Thread*)this,desc,floatType,uav->ObjectName()); // diamond inheritance
+    for(int i=0;i<2;i++) {
+        prev_value->SetValue(i,0,0);
+    }
+
+    opticalFlowSpeedFiltered=new LowPassFilter(opticalFlowSpeed,uav->GetVerticalCamera()->GetLayout()->NewRow(),"passe bas",prev_value);
+// delete prev_value?
+
+    getFrameworkManager()->AddDeviceToLog(opticalFlowSpeed);
+
+    Tab* opticalFlowTab=new Tab(getFrameworkManager()->GetTabWidget(),"flux optique");
+    DataPlot1D* xVelocityPlot=new DataPlot1D(opticalFlowTab->NewRow(),"x_velocity",-5,5);
+    DataPlot1D* yVelocityPlot=new DataPlot1D(opticalFlowTab->LastRowLastCol(),"y_velocity",-5,5);
+
+    xVelocityPlot->AddCurve(opticalFlowSpeed->Output()->Element(0,0));
+    xVelocityPlot->AddCurve(opticalFlowSpeedFiltered->Matrix()->Element(0,0),DataPlot::Blue);
+    yVelocityPlot->AddCurve(opticalFlowSpeed->Output()->Element(1,0));
+    yVelocityPlot->AddCurve(opticalFlowSpeedFiltered->Matrix()->Element(1,0),DataPlot::Blue);
+
+    u_x=new Pid(setupLawTab->At(1,0),"u_x");
+    u_x->UseDefaultPlot(graphLawTab->NewRow());
+    u_y=new Pid(setupLawTab->At(1,1),"u_y");
+    u_y->UseDefaultPlot(graphLawTab->LastRowLastCol());
+
+    opticalFlowGroupBox=new GroupBox(GetJoystick()->GetTab()->NewRow(),"consignes fo");
+    maxXSpeed=new DoubleSpinBox(opticalFlowGroupBox->NewRow(),"debattement x"," m/s",-5,5,0.1,1);
+    maxYSpeed=new DoubleSpinBox(opticalFlowGroupBox->LastRowLastCol(),"debattement y"," m/s",-5,5,0.1,1);
+
+    opticalFlowReference=new cvmatrix((const Thread*)this,2,1,floatType);
+    xVelocityPlot->AddCurve(opticalFlowReference->Element(0,0),DataPlot::Green,"consigne");
+    yVelocityPlot->AddCurve(opticalFlowReference->Element(1,0),DataPlot::Green,"consigne");
+
+    customReferenceOrientation= new AhrsData(this,"reference");
+    uav->GetAhrs()->AddPlot(customReferenceOrientation,DataPlot::Yellow);
+    AddDataToControlLawLog(customReferenceOrientation);
+}
+
+void DemoOpticalFlow::SignalEvent(Event_t event) {
+    switch(event) {
+    case Event_t::EnteringControlLoop:
+        opticalFlowReference->SetValue(0,0,GetJoystick()->GetAxisValue(1)*maxXSpeed->Value());//joy axis 0 maps to x displacement
+        opticalFlowReference->SetValue(1,0,GetJoystick()->GetAxisValue(0)*maxYSpeed->Value());//joy axis 1 maps to y displacement
+        break;
+    }
+}
+
+void DemoOpticalFlow::ExtraCheckJoystick(void) {
+    static bool wasOpticalFlowModeButtonPressed=false;
+    // controller button R1 enters optical flow mode
+    if(GetJoystick()->IsButtonPressed(9)) { // R1
+        if (!wasOpticalFlowModeButtonPressed) {
+            wasOpticalFlowModeButtonPressed=true;
+            if (SetOrientationMode(OrientationMode_t::Custom)) {
+                Thread::Info("(Re)entering optical flow mode\n");
+                u_x->Reset();
+                u_y->Reset();
+            } else {
+                Thread::Warn("Could not enter optical flow mode\n");
+            }
+        }
+    } else {
+        wasOpticalFlowModeButtonPressed=false;
+    }
+}
+
+const AhrsData *DemoOpticalFlow::GetReferenceOrientation(void) {
+    Euler refAngles=GetDefaultReferenceOrientation()->GetQuaternion().ToEuler();//to keep default yaw reference
+
+    // /!\ in this demo, the target value is a speed (in pixel/s). As a consequence the error is the difference between the current speed and the target speed
+    Vector2D error, errorVariation; // in Uav coordinate system
+
+    //opticalFlow= matrice de déplacements en pixels entre 2 images consécutives
+    //opticalFlowSpeed=vitesse de déplacement en pixel par seconde (moyenne sur tous les points et division par le delta T)
+    error.x=opticalFlowSpeedFiltered->Output(0,0)-opticalFlowReference->Value(0,0);
+    error.y=opticalFlowSpeedFiltered->Output(1,0)-opticalFlowReference->Value(1,0);
+
+    //la dérivée est à la fréquence de la loi de commande ("rapide") alors que le flux optique est à la fréquence de la caméra
+    // fréquemment la dérivée car le signal n'a pas bougé -> dérivée super crade
+    //gsanahuj: brancher un eulerderivative derriere le opticalFlowSpeedFiltered pour avoir la derivee
+    //opticalFlowSpeed doit etre renomme car finalement ce n'est pas une vitesse mais un deplacement
+    errorVariation.x=0;
+    errorVariation.y=0;
+
+    u_x->SetValues(error.x, errorVariation.x);
+    u_x->Update(GetTime());
+    refAngles.pitch=u_x->Output();
+
+    u_y->SetValues(error.y, errorVariation.y);
+    u_y->Update(GetTime());
+    refAngles.roll=-u_y->Output();
+
+    customReferenceOrientation->SetQuaternionAndAngularRates(refAngles.ToQuaternion(),Vector3D(0,0,0));
+
+    return customReferenceOrientation;
+}
+
+DemoOpticalFlow::~DemoOpticalFlow() {
+}
Index: /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/src/DemoOpticalFlow.h	(revision 122)
@@ -0,0 +1,63 @@
+//  created:    2011/05/01
+//  filename:   DemoOpticalFlow.h
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    demo optical flow
+//
+//
+/*********************************************************************/
+//------------
+
+#ifndef DEMOOPTICALFLOW_H
+#define DEMOOPTICALFLOW_H
+
+#include <UavStateMachine.h>
+
+namespace flair {
+    namespace core {
+        class cvmatrix;
+    }
+    namespace gui {
+        class GroupBox;
+        class DoubleSpinBox;
+    }
+    namespace filter {
+        class OpticalFlow;
+        class OpticalFlowSpeed;
+        class LowPassFilter;
+        class CvtColor;
+    }
+    namespace sensor {
+        class TargetController;
+    }
+}
+
+class DemoOpticalFlow : public flair::meta::UavStateMachine {
+
+    public:
+        DemoOpticalFlow(flair::sensor::TargetController *controller);
+        ~DemoOpticalFlow();
+
+    protected:
+        void SignalEvent(Event_t event);
+        void ExtraCheckJoystick(void);
+        const flair::core::AhrsData *GetReferenceOrientation(void);
+
+        flair::gui::GroupBox* opticalFlowGroupBox;
+        flair::gui::DoubleSpinBox *maxXSpeed,*maxYSpeed;
+        flair::core::cvmatrix *opticalFlowReference;
+        flair::filter::Pid *u_x, *u_y;
+        flair::filter::LowPassFilter* opticalFlowSpeedFiltered;
+        flair::filter::CvtColor* greyCameraImage;
+        flair::core::AhrsData *customReferenceOrientation;
+
+    private:
+        flair::filter::OpticalFlow *opticalFlow;
+        flair::filter::OpticalFlowSpeed *opticalFlowSpeed;
+};
+
+#endif // DEMOOPTICALFLOW_H
Index: /trunk/demos/OpticalFlow/uav/src/main.cpp
===================================================================
--- /trunk/demos/OpticalFlow/uav/src/main.cpp	(revision 122)
+++ /trunk/demos/OpticalFlow/uav/src/main.cpp	(revision 122)
@@ -0,0 +1,107 @@
+//  created:    2011/05/01
+//  filename:   main.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    exemple de code x4
+//
+//
+/*********************************************************************/
+
+#include "DemoOpticalFlow.h"
+#include <UavFactory.h>
+#include <FrameworkManager.h>
+#include <stdio.h>
+#include <tclap/CmdLine.h>
+#include <TargetEthController.h>
+#include <init.h>
+
+using namespace TCLAP;
+using namespace std;
+using namespace flair::core;
+using namespace flair::meta;
+using namespace flair::sensor;
+
+string uav_type;
+string dsp_file;
+string log_path;
+int port;
+int ds3port;
+string xml_file;
+string name;
+string address;
+
+void parseOptions(int argc, char** argv);
+
+
+int main(int argc, char* argv[]) {
+    parseOptions(argc,argv);
+
+    FrameworkManager *manager;
+    manager= new FrameworkManager(name);
+    manager->SetupConnection(address,port);
+    manager->SetupUserInterface(xml_file);
+    manager->SetupLogger(log_path);
+    SetupDSP(dsp_file);
+
+    Uav* drone=CreateUav(name,uav_type);
+    TargetEthController *controller=new TargetEthController(manager,"Dualshock3",ds3port);
+    DemoOpticalFlow* demo=new DemoOpticalFlow(controller);
+
+    demo->Start();
+    demo->Join();
+
+    delete manager;
+
+    CloseDSP();
+}
+
+void parseOptions(int argc, char** argv)
+{
+	try
+	{
+
+        CmdLine cmd("Command description message", ' ', "0.1");
+
+        ValueArg<string> nameArg("n","name","uav name",true,"x4","string");
+        cmd.add( nameArg );
+
+        ValueArg<string> typeArg("t","type","uav type: ardrone2, hds_x4, hds_x8, hds_xufo, hds_simu or hds_simux (with x the number of the simulated uav)",true,"hds_x4","string");
+        cmd.add( typeArg );
+
+        ValueArg<string> dspArg("v","dsp","executable dsp",true,"./dspcv_dsp.out","string");
+        cmd.add( dspArg );
+
+        ValueArg<string> xmlArg("x","xml","fichier xml",true,"./reglages.xml","string");
+        cmd.add( xmlArg );
+
+        ValueArg<string> logsArg("l","logs","repertoire des logs",true,"/media/ram","string");
+        cmd.add( logsArg );
+
+        ValueArg<int> portArg("p","port","port pour station sol",true,9000,"int");
+        cmd.add( portArg );
+
+        ValueArg<string> addressArg("a","address","addresse station sol",true,"127.0.0.1","string");
+        cmd.add( addressArg );
+
+        ValueArg<int> ds3portArg("d","ds3_port","port pour ds3",false,20000,"int");
+        cmd.add( ds3portArg );
+
+        cmd.parse( argc, argv );
+
+        // Get the value parsed by each arg.
+        uav_type=typeArg.getValue();
+        dsp_file = dspArg.getValue();
+        log_path = logsArg.getValue();
+        port=portArg.getValue();
+        ds3port=ds3portArg.getValue();
+        xml_file = xmlArg.getValue();
+        name=nameArg.getValue();
+        address=addressArg.getValue();
+
+	} catch (ArgException &e)  // catch any exceptions
+	{ cerr << "error: " << e.error() << " for arg " << e.argId() << endl; }
+}
